package json;

import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import type2.Type2GrammarGenerator;

public class GrammarToJSON {

	private static String createJSONGrammar(String[] vars, int alphaSize, Map<String, List<List<String>>> rules,
			String start) {
		JSONObject grammarJSON = new JSONObject();
		JSONArray varsJSON = new JSONArray();
		for (String v : vars) {
			varsJSON.add(new JSONString(v));
		}
		JSONArray termsJSON = new JSONArray();
		for (int i = 97; i < 97 + alphaSize; i++) {
			termsJSON.add(new JSONString(((char) i) + ""));
		}
		JSONArray rulesJSON = new JSONArray();
		int ruleNo = 1;
		for (Entry<String, List<List<String>>> rule : rules.entrySet()) {
			String premise = rule.getKey();
			for (List<String> conclusio : rule.getValue()) {
				JSONObject ruleJSON = new JSONObject();
				JSONArray conclusioJSON = new JSONArray();
				for (String c : conclusio) {
					conclusioJSON.add(new JSONString(c));
				}
				ruleJSON.put("ruleNo", new JSONNumber(ruleNo++));
				ruleJSON.put("premise", new JSONString(premise));
				ruleJSON.put("conclusio", conclusioJSON);
				rulesJSON.add(ruleJSON);
			}
		}
		grammarJSON.put("variables", varsJSON);
		grammarJSON.put("terminals", termsJSON);
		grammarJSON.put("rules", rulesJSON);
		grammarJSON.put("start", new JSONString(start));
		return grammarJSON.toString();
	}

	public static void main(String[] args) {
		Type2GrammarGenerator g = new Type2GrammarGenerator();
		String[] vars = { "S", "A" };
		Map<String, List<List<String>>> rules = g.genType2GrammarRuleSet(vars, 2, 2, 2);
		System.out.println(rules);
		System.out.println(createJSONGrammar(vars, 2, rules, "S"));
	}

}
